--- res_musiconhold.c.orig	2004-04-18 02:30:44.000000000 -0300
+++ res_musiconhold.c	2004-04-18 02:37:52.000000000 -0300
@@ -108,27 +108,30 @@
 	char xargs[256];
 	char *argptr;
 	int argc;
-	DIR *dir;
+	DIR *dir=NULL;
 	struct dirent *de;
-	dir = opendir(class->dir);
-	if (!dir) {
-		ast_log(LOG_WARNING, "%s is not a valid directory\n", class->dir);
-		return -1;
- 	}
 	argv[0] = "mpg123";
 	argv[1] = "-q";
 	argv[2] = "-s";
 	argv[3] = "--mono";
 	argv[4] = "-r";
 	argv[5] = "8000";
-	argv[6] = "-b";
-	argv[7] = "2048";
-	argv[8] = "-f";
-	argc = 9;
+	argv[6] = "-f";
+	argc = 7;
 	if (class->quiet) {
 		argv[argc++] = "4096";
 	} else
 		argv[argc++] = "8192";
+	if (!strcasecmp(class->dir, "http://"))
+	{
+		dir = opendir(class->dir);
+		if (!dir) {
+			ast_log(LOG_WARNING, "%s is not a valid directory\n", class->dir);
+			return -1;
+	 	}
+		argv[argc++] = "-b";
+		argv[argc++] = "2048";
+	}
 
 	/* Look for extra arguments and add them to the list */
 	strncpy(xargs, class->miscargs, sizeof(xargs) - 1);
@@ -142,16 +145,23 @@
 		}
 	}
 
-	files = 0;
-	while((de = readdir(dir)) && (files < MAX_MP3S)) {
-		if ((strlen(de->d_name) > 3) && !strcasecmp(de->d_name + strlen(de->d_name) - 4, ".mp3")) {
-			strncpy(fns[files], de->d_name, sizeof(fns[files]));
-			argv[argc++] = fns[files];
-			files++;
+	if (!strcasecmp(class->dir, "http://"))
+	{
+		files = 0;
+		while((de = readdir(dir)) && (files < MAX_MP3S)) {
+			if ((strlen(de->d_name) > 3) && !strcasecmp(de->d_name + strlen(de->d_name) - 4, ".mp3")) {
+				strncpy(fns[files], de->d_name, sizeof(fns[files]));
+				argv[argc++] = fns[files];
+				files++;
+			}
 		}
+		argv[argc] = NULL;
+		closedir(dir);
+	} else {
+		files = 1;
+		argv[argc++] = class->dir;
+		argv[argc] = NULL;
 	}
-	argv[argc] = NULL;
-	closedir(dir);
 	if (pipe(fds)) {	
 		ast_log(LOG_WARNING, "Pipe failed\n");
 		return -1;
